#include "stdafx.h"
#include "CGrepAgent.h"
#include "util/window.h"
#include "CRunningTimer.h"
#include "dlg/CDlgCancel.h"
#include "COpeBlk.h"
#include "util/module.h"
#include "io/CFileLoad.h"
#include "charset/CCodeMediator.h"
#include "parse/CWordParse.h"
#include "CGrepEnumKeys.h"
#include "CGrepEnumFilterFiles.h"
#include "CGrepEnumFilterFolders.h"

CGrepAgent::CGrepAgent()
: m_bGrepMode( false )			/* Grep[h */
, m_bGrepRunning( false )		/* Grep */
{
}

ECallbackResult CGrepAgent::OnBeforeClose()
{
	//GREP͏IłȂ
	if( m_bGrepRunning ){
		// ANeBuɂ
		ActivateFrameWindow( CEditWnd::Instance()->GetHwnd() );	//@@@ 2003.06.25 MIK
		TopInfoMessage(
			CEditWnd::Instance()->GetHwnd(),
			_T("Grep̏łB\n")
		);
		return CALLBACK_INTERRUPT;
	}
	return CALLBACK_CONTINUE;
}



// Greps
DWORD CGrepAgent::DoGrep(
	CEditView*				pcViewDst,
	const CNativeW*			pcmGrepKey,
	const CNativeT*			pcmGrepFile,
	const CNativeT*			pcmGrepFolder,
	BOOL					bGrepSubFolder,
	const SSearchOption&	sSearchOption,
	ECodeType				nGrepCharSet,	// 2002/09/21 Moca R[hZbgI
	BOOL					bGrepOutputLine,
	int						nGrepOutputStyle
)
{
#ifdef _DEBUG
	CRunningTimer cRunningTimer( "CEditView::DoGrep" );
#endif

	this->m_bGrepRunning = true;


	int			nDummy;
	int			nHitCount = 0;
	wchar_t		szKey[_MAX_PATH];
	TCHAR		szFile[_MAX_PATH];
	CDlgCancel	cDlgCancel;
	HWND		hwndCancel;
	int			nCharChars;
	//	Jun. 27, 2001 genta	K\Cu̍ւ
	CBregexp	cRegexp;
	CNativeW	cmemMessage;
	int			nWork;
	int*		pnKey_CharCharsArr;
	pnKey_CharCharsArr = NULL;

	/*
	|| obt@TCY̒
	*/
	cmemMessage.AllocStringBuffer( 4000 );

	pcViewDst->m_bDoing_UndoRedo		= true;


	/* AhDobt@̏ */
	if( NULL != pcViewDst->m_pcOpeBlk ){	/* ubN */
//@@@2002.2.2 YAZAKI NULLȂƐi܂Ȃ̂ŁAƂ肠RgBNULL̂Ƃ́Anew COpeBlkB
//		while( NULL != m_pcOpeBlk ){}
//		delete m_pcOpeBlk;
//		m_pcOpeBlk = NULL;
	}
	else {
		pcViewDst->m_pcOpeBlk = new COpeBlk;
	}

	pcViewDst->m_bCurSrchKeyMark = true;								/* ̃}[N */
	wcscpy( pcViewDst->m_szCurSrchKey, pcmGrepKey->GetStringPtr() );	/*  */
	pcViewDst->m_sCurSearchOption.bRegularExp = sSearchOption.bRegularExp;		/* ^u  1==K\ */
	pcViewDst->m_sCurSearchOption.bLoHiCase   = sSearchOption.bLoHiCase;			/* ^u  1==p啶̋ */
	/* K\ */

	//	From Here Jun. 27 genta
	/*
		GrepsɓČEʐFpK\obt@
		DGrepʂ̐Fs߁D

		Note: ŋ͍̂Ō̌ł
		GrepΏۃp^[ł͂ȂƂɒ
	*/
	if( pcViewDst->m_sCurSearchOption.bRegularExp ){
		//	Jun. 27, 2001 genta	K\Cu̍ւ
		if( !InitRegexp( pcViewDst->GetHwnd(), pcViewDst->m_CurRegexp, true ) ){
			return 0;
		}

		/* p^[̃RpC */
		int nFlag = 0x00;
		nFlag |= pcViewDst->m_sCurSearchOption.bLoHiCase ? 0x01 : 0x00;
		pcViewDst->m_CurRegexp.Compile( pcViewDst->m_szCurSrchKey, nFlag );
	}
	//	To Here Jun. 27 genta

//܂ m_bCurSrchWordOnly = GetDllShareData().m_Common.m_bWordOnly;	/* ^u  1==P̂݌ */

//	cDlgCancel.Create( m_hInstance, m_hwndParent );
//	hwndCancel = cDlgCancel.Open( MAKEINTRESOURCE(IDD_GREPRUNNING) );
	hwndCancel = cDlgCancel.DoModeless( pcViewDst->m_hInstance, pcViewDst->m_hwndParent, IDD_GREPRUNNING );

	::SetDlgItemInt( hwndCancel, IDC_STATIC_HITCOUNT, 0, FALSE );
	::DlgItem_SetText( hwndCancel, IDC_STATIC_CURFILE, _T(" ") );	// 2002/09/09 Moca add
	::CheckDlgButton( hwndCancel, IDC_CHECK_REALTIMEVIEW, GetDllShareData().m_Common.m_sSearch.m_bGrepRealTimeView );	// 2003.06.23 Moca

	wcscpy( szKey, pcmGrepKey->GetStringPtr() );

	wcscpy( CAppMode::Instance()->m_szGrepKey, szKey );
	this->m_bGrepMode = true;

	//	2007.07.22 genta
	//	o[Wԍ擾̂߁CO̕ֈړ
	if( sSearchOption.bRegularExp ){
		if( !InitRegexp( pcViewDst->GetHwnd(), cRegexp, true ) ){
			return 0;
		}
		/* p^[̃RpC */
		int nFlag = 0x00;
		nFlag |= sSearchOption.bLoHiCase ? 0x01 : 0x00;
		if( !cRegexp.Compile( szKey, nFlag ) ){
			return 0;
		}
	}else{
		/* ̏ */
		CSearchAgent::CreateCharCharsArr(
			szKey,
			wcslen( szKey ),
			&pnKey_CharCharsArr
		);
	}

//2002.02.08 GrepACR傫ACRƏACRʁXɂB
	HICON	hIconBig, hIconSmall;
	//	Dec, 2, 2002 genta ACRǂݍݕ@ύX
	hIconBig   = GetAppIcon( pcViewDst->m_hInstance, ICON_DEFAULT_GREP, FN_GREP_ICON, false );
	hIconSmall = GetAppIcon( pcViewDst->m_hInstance, ICON_DEFAULT_GREP, FN_GREP_ICON, true );

	//	Sep. 10, 2002 genta
	//	CEditWndɐV݂֐g悤
	CEditWnd*	pCEditWnd = CEditWnd::Instance();	//	Sep. 10, 2002 genta
	pCEditWnd->SetWindowIcon( hIconSmall, ICON_SMALL );
	pCEditWnd->SetWindowIcon( hIconBig, ICON_BIG );

	TCHAR szPath[_MAX_PATH];
	_tcscpy( szPath, pcmGrepFolder->GetStringPtr() );
	nDummy = _tcslen( szPath );

	/* tH_̍Ōオup'\\'vłȂꍇ́At */
	nCharChars = &szPath[nDummy] - CNativeT::GetCharPrev( szPath, nDummy, &szPath[nDummy] );
	if( 1 == nCharChars && szPath[nDummy - 1] == _T('\\') ){
	}else{
		_tcscat( szPath, _T("\\") );
	}
	_tcscpy( szFile, pcmGrepFile->GetStringPtr() );

	nWork = wcslen( szKey ); // 2003.06.10 Moca 炩ߒvZĂ

	/* ŌɃeLXgǉ */
	CNativeW	cmemWork;
	cmemMessage.AppendString( L"\r\n  " );
	if( 0 < nWork ){
		CNativeW cmemWork2;
		cmemWork2.SetString( szKey );
		if( pcViewDst->m_pcEditDoc->m_cDocType.GetDocumentAttribute().m_nStringType == 0 ){	/* ؂LGXP[v@  0=[\"][\'] 1=[""][''] */
			cmemWork2.Replace( L"\\", L"\\\\" );
			cmemWork2.Replace( L"\'", L"\\\'" );
			cmemWork2.Replace( L"\"", L"\\\"" );
		}else{
			cmemWork2.Replace( L"\'", L"\'\'" );
			cmemWork2.Replace( L"\"", L"\"\"" );
		}
		cmemWork.AppendString( L"\"" );
		cmemWork.AppendNativeData( cmemWork2 );
		cmemWork.AppendString( L"\"\r\n" );
	}else{
		cmemWork.AppendString( L"ut@Cv\r\n" );
	}
	cmemMessage += cmemWork;



	cmemMessage.AppendString( L"Ώ   " );
	cmemWork.SetStringT( szFile );
	if( pcViewDst->m_pcEditDoc->m_cDocType.GetDocumentAttribute().m_nStringType == 0 ){	/* ؂LGXP[v@  0=[\"][\'] 1=[""][''] */
	}else{
	}
	cmemMessage += cmemWork;




	cmemMessage.AppendString( L"\r\n" );
	cmemMessage.AppendString( L"tH_   " );
	cmemWork.SetStringT( szPath );
	if( pcViewDst->m_pcEditDoc->m_cDocType.GetDocumentAttribute().m_nStringType == 0 ){	/* ؂LGXP[v@  0=[\"][\'] 1=[""][''] */
	}else{
	}
	cmemMessage += cmemWork;
	cmemMessage.AppendString( L"\r\n" );

	const wchar_t*	pszWork;
	if( bGrepSubFolder ){
		pszWork = L"    (TutH_)\r\n";
	}else{
		pszWork = L"    (TutH_Ȃ)\r\n";
	}
	cmemMessage.AppendString( pszWork );

	if( 0 < nWork ){ // 2003.06.10 Moca t@C̏ꍇ͕\Ȃ // 2004.09.26 C
		if( sSearchOption.bWordOnly ){
		/* PPʂŒT */
			cmemMessage.AppendString( L"    (PPʂŒT)\r\n" );
		}

		if( sSearchOption.bLoHiCase ){
			pszWork = L"    (p啶ʂ)\r\n";
		}else{
			pszWork = L"    (p啶ʂȂ)\r\n";
		}
		cmemMessage.AppendString( pszWork );

		if( sSearchOption.bRegularExp ){
			//	2007.07.22 genta : K\Cũo[Wo͂
			cmemMessage.AppendString( L"    (K\:" );
			cmemMessage.AppendStringT( cRegexp.GetVersionT() );
			cmemMessage.AppendString( L")\r\n" );
		}
	}

	if( CODE_AUTODETECT == nGrepCharSet ){
		cmemMessage.AppendString( L"    (R[hZbg̎)\r\n" );
	}else if(IsValidCodeType(nGrepCharSet)){
		cmemMessage.AppendString( L"    (R[hZbgF" );
		cmemMessage.AppendStringT( CCodeTypeName(nGrepCharSet).Normal() );
		cmemMessage.AppendString( L")\r\n" );
	}

	if( 0 < nWork ){ // 2003.06.10 Moca t@C̏ꍇ͕\Ȃ // 2004.09.26 C
		if( bGrepOutputLine ){
		/* Ys */
			pszWork = L"    (vso)\r\n";
		}else{
			pszWork = L"    (vӏ̂ݏo)\r\n";
		}
		cmemMessage.AppendString( pszWork );
	}


	cmemMessage.AppendString( L"\r\n\r\n" );
	pszWork = cmemMessage.GetStringPtr( &nWork );
//@@@ 2002.01.03 YAZAKI Grep̓J[\GrepÖʒuɓ
	CLayoutInt tmp_PosY_Layout = pcViewDst->m_pcEditDoc->m_cLayoutMgr.GetLineCount();
	if( 0 < nWork ){
		pcViewDst->GetCommander().Command_ADDTAIL( pszWork, nWork );
	}
	//	2007.07.22 genta o[W擾邽߂ɁC
	//	K\̏ֈړ


	/* \ON/OFF */
	// 2003.06.23 Moca ʐݒŕύXł悤
//	SetDrawSwitch(false);
	pcViewDst->SetDrawSwitch(0 != GetDllShareData().m_Common.m_sSearch.m_bGrepRealTimeView);

	CGrepEnumKeys cGrepEnumKeys;
	cGrepEnumKeys.SetKeys( szFile );

	int nGrepTreeResult = DoGrepTree(
		pcViewDst,
		&cDlgCancel,
		hwndCancel,
		szKey,
		pnKey_CharCharsArr,
		cGrepEnumKeys,
		szPath,
		bGrepSubFolder,
		sSearchOption,
		nGrepCharSet,
		bGrepOutputLine,
		nGrepOutputStyle,
		&cRegexp,
		0,
		&nHitCount
	);
	if( -1 == nGrepTreeResult ){
		const wchar_t* p = L"f܂B\r\n";
		pcViewDst->GetCommander().Command_ADDTAIL( p, wcslen( p ) );
	}
	auto_sprintf( szPath, _T("%d ܂B\r\n"), nHitCount );
	pcViewDst->GetCommander().Command_ADDTAIL( to_wchar(szPath), -1 );
//	GetCommander().Command_GOFILEEND( FALSE );
#ifdef _DEBUG
	auto_sprintf( szPath, _T(": %d~b\r\n"), cRunningTimer.Read() );
	pcViewDst->GetCommander().Command_ADDTAIL( to_wchar(szPath), -1 );
#endif

	pcViewDst->GetCaret().MoveCursor( CLayoutPoint(CLayoutInt(0), tmp_PosY_Layout), TRUE );	//	J[\GrepÖʒuɖ߂B

	cDlgCancel.CloseDialog( 0 );

	/* ANeBuɂ */
	ActivateFrameWindow( CEditWnd::Instance()->GetHwnd() );


	/* AhDobt@̏ */
	if( NULL != pcViewDst->m_pcOpeBlk ){
		if( 0 < pcViewDst->m_pcOpeBlk->GetNum() ){	/* ̐Ԃ */
			/* ̒ǉ */
			pcViewDst->m_pcEditDoc->m_cDocEditor.m_cOpeBuf.AppendOpeBlk( pcViewDst->m_pcOpeBlk );
		}
		else{
			delete pcViewDst->m_pcOpeBlk;
		}
		pcViewDst->m_pcOpeBlk = NULL;
	}

	//	Apr. 13, 2001 genta
	//	Greps̓t@CύX̏ԂɂD
	pcViewDst->m_pcEditDoc->m_cDocEditor.SetModified(false,false);

	this->m_bGrepRunning = false;
	pcViewDst->m_bDoing_UndoRedo = false;

	if( NULL != pnKey_CharCharsArr ){
		delete [] pnKey_CharCharsArr;
		pnKey_CharCharsArr = NULL;
	}
//	if( NULL != pnKey_CharUsedArr ){
//		delete [] pnKey_CharUsedArr;
//		pnKey_CharUsedArr = NULL;
//	}

	/* \ON/OFF */
	pcViewDst->SetDrawSwitch(true);

	/* tH[JXړ̍ĕ` */
	pcViewDst->RedrawAll();

	return nHitCount;
}



/*
 * SORTED_LIST_BSEARCH
 *   Xg̒Tbsearchg܂B
 *   w肵Ȃꍇ́A`TɂȂ܂B
 * SORTED_LIST
 *   Xgqsort܂B
 *
 * F
 *   `TłqsortgAȓ召֌Wt]ƂŒT
 *   ł؂Ώ͑܂B
 */
//#define SORTED_LIST
//#define SORTED_LIST_BSEARCH

#ifdef SORTED_LIST_BSEARCH
#define SORTED_LIST
#endif

#ifdef SORTED_LIST
typedef int (* COMP)(const void *, const void *);

/*!
	qsortpr֐
	a,b͕ւ̃|C^̃|C^ł邱ƂɒӁB
	
	@param a [in] rւ̃|C^̃|C^(list)
	@param b [in] rւ̃|C^̃|C^(list)
	@return r
*/
int grep_compare_pp(const void* a, const void* b)
{
	return _tcscmp( *((const TCHAR**)a), *((const TCHAR**)b) );
}

/*!
	bsearchpr֐
	b͕ւ̃|C^̃|C^ł邱ƂɒӁB
	
	@param a [in] rւ̃|C^(key)
	@param b [in] rւ̃|C^̃|C^(list)
	@return r
*/
int grep_compare_sp(const void* a, const void* b)
{
	return _tcscmp( (const TCHAR*)a, *((const TCHAR**)b) );
}
#endif

/*! @brief Greps

	@date 2001.06.27 genta	K\Cu̍ւ
	@date 2003.06.23 Moca   TutH_t@Ĉt@CTutH_̏ɕύX
	@date 2003.06.23 Moca   t@C""菜悤
	@date 2003.03.27 ݂   Ot@Cw̓Ədh~̒ǉD
		啔ύXꂽ߁Cʂ̕ύX_L͖D
*/
int CGrepAgent::DoGrepTree(
	CEditView*				pcViewDst,
	CDlgCancel*				pcDlgCancel,		//!< [in] Cancel_CAOւ̃|C^
	HWND					hwndCancel,			//!< [in] Cancel_CAÕEBhEnh
	const wchar_t*			pszKey,				//!< [in] p^[
	int*					pnKey_CharCharsArr,	//!< [in] z(2byte/1byte)DP񌟍ŎgpD
	CGrepEnumKeys&			cGrepEnumKeys,		//!< [in] Ώۃt@Cp^[(!ŏOw)
	const TCHAR*			pszPath,			//!< [in] ΏۃpX
	BOOL					bGrepSubFolder,		//!< [in] TRUE: TutH_ċAIɒT / FALSE: Ȃ
	const SSearchOption&	sSearchOption,		//!< [in] IvV
	ECodeType				nGrepCharSet,		//!< [in] R[hZbg (0:F)`
	BOOL					bGrepOutputLine,	//!< [in] TRUE: qbgso / FALSE: qbgo
	int						nGrepOutputStyle,	//!< [in] o͌` 1: Normal, 2: WZ(t@CP)
	CBregexp*				pRegexp,			//!< [in] K\RpCf[^BɃRpCĂKv
	int						nNest,				//!< [in] lXgx
	int*					pnHitCount			//!< [i/o] qbg̍v
)
{
	::DlgItem_SetText( hwndCancel, IDC_STATIC_CURPATH, pszPath );

	int			i;
	int			count;
	CNativeW	cmemMessage;
	LPCTSTR		pszWork;
	LPCTSTR		lpFileName;
	int			nWork = 0;
	int			nHitCountOld = -100;

	CGrepEnumFilterFiles cGrepEnumFilterFiles;
	cGrepEnumFilterFiles.Enumerates( pszPath, cGrepEnumKeys );

	/*
	 * JgtH_̃t@CTB
	 */
	count = cGrepEnumFilterFiles.GetCount();
	for( i = 0; i < count; i++ ){
		lpFileName = cGrepEnumFilterFiles.GetFileName( i );

		/* ̃[U[\ɂ */
		if( !::BlockingHook( pcDlgCancel->GetHwnd() ) ){
			goto cancel_return;
		}
		/* f{^`FbN */
		if( pcDlgCancel->IsCanceled() ){
			goto cancel_return;
		}

		/* \ݒ`FbN */
		pcViewDst->SetDrawSwitch(0 != ::IsDlgButtonChecked( pcDlgCancel->GetHwnd(), IDC_CHECK_REALTIMEVIEW ));

		//GREPsI
		::DlgItem_SetText( hwndCancel, IDC_STATIC_CURFILE, lpFileName );

		TCHAR* currentFile = new TCHAR[ _tcslen( pszPath ) + _tcslen( lpFileName ) + 1 ];
		if( ! currentFile ) goto error_return;	//mێs
		_tcscpy( currentFile, pszPath );
		_tcscat( currentFile, lpFileName );
		/* t@Č */
		int nRet = DoGrepFile(
			pcViewDst,
			pcDlgCancel,
			hwndCancel,
			pszKey,
			pnKey_CharCharsArr,
			lpFileName,
			sSearchOption,
			nGrepCharSet,
			bGrepOutputLine,
			nGrepOutputStyle,
			pRegexp,
			pnHitCount,
			currentFile,
			cmemMessage
		);
		delete currentFile;
		currentFile = NULL;

		// 2003.06.23 Moca A^C\̂Ƃ͑߂ɕ\
		if( pcViewDst->GetDrawSwitch() ){
			if( LTEXT('\0') != pszKey[0] ){
				// f[^̂Ƃt@C̍vő10MB𒴂\
				nWork += ( cGrepEnumFilterFiles.GetFileSizeLow( i ) + 1023 ) / 1024;
			}
			if( *pnHitCount - nHitCountOld && 
				( *pnHitCount < 20 || 10000 < nWork ) ){
				nHitCountOld = -100; // \
			}
		}
		if( *pnHitCount - nHitCountOld  >= 10 ){
			/* ʏo */
			pszWork = cmemMessage.GetStringPtr( &nWork );
			if( 0 < nWork ){
				pcViewDst->GetCommander().Command_ADDTAIL( pszWork, nWork );
				pcViewDst->GetCommander().Command_GOFILEEND( FALSE );
				/* ʊi[GANA */
				cmemMessage.SetString( L"" );
				nWork = 0;
			}
			nHitCountOld = *pnHitCount;
		}
		if( -1 == nRet ){
			goto cancel_return;
		}
	}

	/*
	 * TutH_B
	 */
	if( bGrepSubFolder ){
		CGrepEnumFilterFolders cGrepEnumFilterFolders;
		cGrepEnumFilterFolders.Enumerates( pszPath, cGrepEnumKeys );

		count = cGrepEnumFilterFolders.GetCount();
		for( i = 0; i < count; i++ ){
			lpFileName = cGrepEnumFilterFolders.GetFileName( i );

			//TutH_̒TċAĂяoB
			/* ̃[U[\ɂ */
			if( !::BlockingHook( pcDlgCancel->GetHwnd() ) ){
				goto cancel_return;
			}
			/* f{^`FbN */
			if( pcDlgCancel->IsCanceled() ){
				goto cancel_return;
			}
			/* \ݒ`FbN */
			pcViewDst->SetDrawSwitch(0 != ::IsDlgButtonChecked( pcDlgCancel->GetHwnd(), IDC_CHECK_REALTIMEVIEW ));

			//tH_쐬B
			TCHAR* currentPath = NULL;	//ݒT̃pX
			currentPath = new TCHAR[ _tcslen( pszPath ) + _tcslen( lpFileName ) + 2 ];
			if( ! currentPath ) goto error_return;	//mێs
			_tcscpy( currentPath, pszPath );
			_tcscat( currentPath, lpFileName );
			_tcscat( currentPath, _T("\\") );

			int nGrepTreeResult = DoGrepTree(
				pcViewDst,
				pcDlgCancel,
				hwndCancel,
				pszKey,
				pnKey_CharCharsArr,
				cGrepEnumKeys,
				currentPath,
				bGrepSubFolder,
				sSearchOption,
				nGrepCharSet,
				bGrepOutputLine,
				nGrepOutputStyle,
				pRegexp,
				nNest + 1,
				pnHitCount
			);
			delete [] currentPath;
			currentPath = NULL;

			if( -1 == nGrepTreeResult ){
				goto cancel_return;
			}
			::DlgItem_SetText( hwndCancel, IDC_STATIC_CURPATH, pszPath );	//@@@ 2002.01.10 add TutH_߂Ă...
		}
	}

	::DlgItem_SetText( hwndCancel, IDC_STATIC_CURFILE, LTEXT(" ") );	// 2002/09/09 Moca add
	/* ʏo */
	pszWork = cmemMessage.GetStringPtr( &nWork );
	if( 0 < nWork ){
		pcViewDst->GetCommander().Command_ADDTAIL( pszWork, nWork );
		pcViewDst->GetCommander().Command_GOFILEEND( FALSE );
		/* ʊi[GANA */
		cmemMessage.SetString( LTEXT("") );
	}

	return 0;


cancel_return:;
error_return:;
	/* ʏo */
	pszWork = cmemMessage.GetStringPtr( &nWork );
	if( 0 < nWork )
	{
		pcViewDst->GetCommander().Command_ADDTAIL( pszWork, nWork );
		pcViewDst->GetCommander().Command_GOFILEEND( FALSE );
		/* ʊi[GANA */
		cmemMessage.SetString( LTEXT("") );
	}

	return -1;
}




/*!	@brief Grepʂ\z

	@param pWork [out] Grepo͕D[ȃ̈\ߊmۂĂƁD
		Œ {2000 byte{t@C _MAX_PATH byte{sEʒu\̒KvD
		t@CPʏo͂̏ꍇ͖{2500 byte + _MAX_PATH + sEʒu\̒KvD
		

	pWork͏[ȃ̈ĂRg
	@date 2002/08/29 Moca oCi[f[^ɑΉ pnWorkLen ǉ
*/
void CGrepAgent::SetGrepResult(
	/* f[^i[ */
	wchar_t*	pWork,
	int*		pnWorkLen,			/*!< [out] Grepo͕̒ */
	/* }b`t@C̏ */
	const TCHAR*		pszFullPath,	/*!< [in] tpX */
	const TCHAR*		pszCodeName,	/*!< [in] R[hD" [SJIS]"Ƃ */
	/* }b`s̏ */
	int			nLine,				/*!< [in] }b`sԍ(1`) */
	int			nColm,				/*!< [in] }b`ԍ(1`) */
	const wchar_t*	pCompareData,	/*!< [in] s̕ */
	int			nLineLen,			/*!< [in] s̒̕ */
	int			nEolCodeLen,		/*!< [in] EOL̒ */
	/* }b`̏ */
	const wchar_t*	pMatchData,		/*!< [in] }b` */
	int			nMatchLen,			/*!< [in] }b`̒ */
	/* IvV */
	BOOL		bGrepOutputLine,	/*!< [in] 0: Ŷ, !0: Ys */
	int			nGrepOutputStyle	/*!< [in] 1: Normal, 2: WZ(t@CP) */
)
{

	int nWorkLen = 0;
	const wchar_t * pDispData;
	int k;
	bool bEOL = true;
	int nMaxOutStr;

	/* m[} */
	if( 1 == nGrepOutputStyle ){
		nWorkLen = ::auto_sprintf( pWork, L"%ls(%d,%d)%ls: ", pszFullPath, nLine, nColm, pszCodeName );
		nMaxOutStr = 2000; // 2003.06.10 Moca ő咷ύX
	}
	/* WZ */
	else if( 2 == nGrepOutputStyle ){
		nWorkLen = ::auto_sprintf( pWork, L"E(%6d,%-5d): ", nLine, nColm );
		nMaxOutStr = 2500; // 2003.06.10 Moca ő咷ύX
	}

	/* Ys */
	if( bGrepOutputLine ){
		pDispData = pCompareData;
		k = nLineLen - nEolCodeLen;
		if( nMaxOutStr < k ){
			k = nMaxOutStr; // 2003.06.10 Moca ő咷ύX
		}
	}
	/* Y */
	else{
		pDispData = pMatchData;
		k = nMatchLen;
		if( nMaxOutStr < k ){
			k = nMaxOutStr; // 2003.06.10 Moca ő咷ύX
		}
		// Yɉs܂ޏꍇ͂̉sR[ĥ܂ܗp(̍sɋsȂ)
		// 2003.06.10 Moca k==0̂ƂɃobt@A_[Ȃ悤
		if( 0 < k && (pMatchData[ k - 1 ] == L'\r' || pMatchData[ k - 1 ] == L'\n') ){
			bEOL = false;
		}
	}

	auto_memcpy( &pWork[nWorkLen], pDispData, k );
	nWorkLen += k;
	if( bEOL ){
		auto_memcpy( &pWork[nWorkLen], L"\r\n", 2 );
		nWorkLen = nWorkLen + 2;
	}
	*pnWorkLen = nWorkLen;
}

/*!
	Greps (CFileLoadgeXg)

	@param pcDlgCancel		[in] Cancel_CAOւ̃|C^
	@param hwndCancel		[in] Cancel_CAÕEBhEnh
	@param pszKey			[in] p^[
	@param pnKey_CharCharsArr	[in] z(2byte/1byte)DP񌟍ŎgpD
	@param pszFile			[in] Ώۃt@C(\p)
	@param bGrepLoHiCase	[in] TRUE: 啶̋ʂ / FALSE: 
	@param bGrepRegularExp	[in] TRUE: p^[͐K\ / FALSE: 
	@param nGrepCharSet		[in] R[hZbg (0:F)`
	@param bGrepOutputLine	[in] TRUE: qbgso / FALSE: qbgo
	@param bWordOnly		[in] TRUE: PPʂňv𔻒f / FALSE: ɂv
	@param nGrepOutputStyle	[in] o͌` 1: Normal, 2: WZ(t@CP)
	@param pRegexp			[in] K\RpCf[^BɃRpCĂKv
	@param pnHitCount		[i/o] qbg̍vDX̒lɌZĕԂD
	@param pszFullPath		[in] Ώۃt@CpX

	@retval -1 GREP̃LZ
	@retval ȊO qbg(t@C̓t@C)

	@date 2002/08/30 Moca CFileLoadgeXg
	@date 2004/03/28 genta svȈnNest, bGrepSubFolder, pszPath폜
*/
int CGrepAgent::DoGrepFile(
	CEditView*				pcViewDst,
	CDlgCancel*				pcDlgCancel,
	HWND					hwndCancel,
	const wchar_t*			pszKey,
	int*					pnKey_CharCharsArr,
	const TCHAR*			pszFile,
	const SSearchOption&	sSearchOption,
	ECodeType				nGrepCharSet,
	BOOL					bGrepOutputLine,
	int						nGrepOutputStyle,
	CBregexp*				pRegexp,		//	Jun. 27, 2001 genta	K\Cu̍ւ
	int*					pnHitCount,
	const TCHAR*			pszFullPath,
	CNativeW&				cmemMessage
)
{
	int		nHitCount;
//	char	szLine[16000];
	wchar_t	szWork[3000]; //  SetGrepResult() Ԃi[łTCYKv
	wchar_t	szWork0[_MAX_PATH + 100];
	int		nLine;
	int		nWorkLen;
	const wchar_t*	pszRes; // 2002/08/29 constt
	ECodeType	nCharCode;
	const wchar_t*	pCompareData; // 2002/08/29 constt
	int		nColm;
	BOOL	bOutFileName;
	bOutFileName = FALSE;
	CEol	cEol;
	int		nEolCodeLen;
	CFileLoad	cfl;
	int		nOldPercent = 0;

	int	nKeyKen = wcslen( pszKey );

	//	ł͐K\RpCf[^͕̏sv

	const TCHAR*	pszCodeName; // 2002/08/29 constt
	pszCodeName = _T("");
	nHitCount = 0;
	nLine = 0;

	/* [̏ꍇ̓t@CԂ */
	// 2002/08/29 s[v̑O炱Ɉړ
	if( 0 == nKeyKen ){
		if( CODE_AUTODETECT == nGrepCharSet ){
			// 2003.06.10 Moca R[hʏɈړD
			// ʃG[łt@CɃJEg邽
			// t@C̓{R[hZbg
			nCharCode = CCodeMediator::CheckKanjiCodeOfFile( pszFullPath );
			if( -1 == nCharCode ){
				pszCodeName = _T("  [(DetectError)]");
			}else{
				pszCodeName = CCodeTypeName(nCharCode).Bracket();
			}
		}
		if( 1 == nGrepOutputStyle ){
		/* m[} */
			auto_sprintf( szWork0, L"%ts%ts\r\n", pszFullPath, pszCodeName );
		}else{
		/* WZ */
			auto_sprintf( szWork0, L"\"%ts\"%ts\r\n", pszFullPath, pszCodeName );
		}
		cmemMessage.AppendString( szWork0 );
		++(*pnHitCount);
		::SetDlgItemInt( hwndCancel, IDC_STATIC_HITCOUNT, *pnHitCount, FALSE );
		return 1;
	}


	try{
	// t@CJ
	// FileCloseŖIɕ邪AĂȂƂ̓fXgN^ŕ
	// 2003.06.10 Moca R[h菈FileOpenōs
	nCharCode = cfl.FileOpen( pszFullPath, nGrepCharSet, 0 );
	if( CODE_AUTODETECT == nGrepCharSet ){
		pszCodeName = CCodeTypeName(nCharCode).Bracket();
	}
	auto_sprintf( szWork0, L"\"%ts\"%ts\r\n", pszFullPath, pszCodeName );
//	/* ̃[U[\ɂ */
	if( !::BlockingHook( pcDlgCancel->GetHwnd() ) ){
		return -1;
	}
	/* f{^`FbN */
	if( pcDlgCancel->IsCanceled() ){
		return -1;
	}

	/* [̏ꍇ̓t@CԂ */
	// 2002/08/29 t@CI[v̎Oֈړ

	//  : cfl.ReadLine  throw \
	CNativeW cUnicodeBuffer;
	int		nLineLen;
	const wchar_t*	pLine;
	while( NULL != ( pLine = cfl.ReadLine( &cUnicodeBuffer, &nLineLen, &cEol ) ) ){
		nEolCodeLen = cEol.GetLen();
		++nLine;
		pCompareData = pLine;

		/* ̃[U[\ɂ */
		if( !::BlockingHook( pcDlgCancel->GetHwnd() ) ){
			return -1;
		}
		if( 0 == nLine % 64 ){
			/* f{^`FbN */
			if( pcDlgCancel->IsCanceled() ){
				return -1;
			}
			//	2003.06.23 Moca \ݒ`FbN
			pcViewDst->SetDrawSwitch(0 != ::IsDlgButtonChecked( pcDlgCancel->GetHwnd(), IDC_CHECK_REALTIMEVIEW ));
			// 2002/08/30 Moca isԂ\(5MBȏ)
			if( 5000000 < cfl.GetFileSize() ){
				int nPercent = cfl.GetPercent();
				if( 5 <= nPercent - nOldPercent ){
					nOldPercent = nPercent;
					::auto_sprintf( szWork, L"%ls (%3d%%)", pszFile, nPercent );
					::DlgItem_SetText( hwndCancel, IDC_STATIC_CURFILE, szWork );
				}
			}
		}

		/* K\ */
		if( sSearchOption.bRegularExp ){
			int nColmPrev = 0;

			//	Jun. 21, 2003 genta [v
			//	}b`ӏ1s畡oP[XWɁC
			//	}b`ӏ1s1oꍇOP[XƂƂ炦C
			//	[vpEł؂(bGrepOutputLine)tɂD
			//	Jun. 27, 2001 genta	K\Cu̍ւ
			// From Here 2005.03.19  ͂BREGEXP\̂ɒڃANZXȂ
			while( pRegexp->Match( pCompareData, nLineLen, 0 ) ){

					//	p^[
					nColm = pRegexp->GetIndex() + 1;
					int matchlen = pRegexp->GetMatchLen();

					/* GrepʂAszWorkɊi[ */
					SetGrepResult(
						szWork,
						&nWorkLen,
						pszFullPath,
						pszCodeName,
						nLine,
						nColm + nColmPrev,
						pCompareData,
						nLineLen,
						nEolCodeLen,
						pCompareData + nColm - 1,
						matchlen,
						bGrepOutputLine,
						nGrepOutputStyle
					);
					// To Here 2005.03.19  ͂BREGEXP\̂ɒڃANZXȂ
					if( 2 == nGrepOutputStyle ){
					/* WZ */
						if( !bOutFileName ){
							cmemMessage.AppendString( szWork0 );
							bOutFileName = TRUE;
						}
					}
					cmemMessage.AppendString( szWork, nWorkLen );
					++nHitCount;
					++(*pnHitCount);
					if( 0 == ( (*pnHitCount) % 16 ) || *pnHitCount < 16 ){
						::SetDlgItemInt( hwndCancel, IDC_STATIC_HITCOUNT, *pnHitCount, FALSE );
					}
					//	Jun. 21, 2003 genta sPʂŏo͂ꍇ1Ώ\
					if ( bGrepOutputLine ) {
						break;
					}
					//	Tn߂ʒu␳
					//	2003.06.10 Moca }b`̌납玟̌Jn
					//	nClom : }b`ʒu
					//	matchlen : }b`̒
					int nPosDiff = nColm + matchlen;
					if( matchlen != 0 ){
						nPosDiff--;
					}
					pCompareData += nPosDiff;
					nLineLen -= nPosDiff;
					nColmPrev += nPosDiff;
			}
		}
		/* P̂݌ */
		else if( sSearchOption.bWordOnly ){
			/*
				2002/02/23 Norio Nakatani
				PPʂGrepIɎBPWhereCurrentWord()ŔʂĂ܂̂ŁA
				pPC/C++ʎqȂǂ̌Ȃqbg܂B

				2002/03/06 YAZAKI
				GrepɂB
				WhereCurrentWordŒP𒊏oāA̒PꂪƂĂ邩rB
			*/
			CLogicInt nNextWordFrom = CLogicInt(0);
			CLogicInt nNextWordFrom2;
			CLogicInt nNextWordTo2;
			// Jun. 26, 2003 genta ʂwhile͍폜
			while( CWordParse::WhereCurrentWord_2( pCompareData, CLogicInt(nLineLen), nNextWordFrom, &nNextWordFrom2, &nNextWordTo2 , NULL, NULL ) ){
				if( nKeyKen == nNextWordTo2 - nNextWordFrom2 ){
					// const char* pData = pCompareData;	// 2002/2/10 aroka CMemoryύX , 2002/08/29 Moca pCompareDataconstɂsv?
					/* 1==啶̋ */
					if( (!sSearchOption.bLoHiCase && 0 == auto_memicmp( &(pCompareData[nNextWordFrom2]) , pszKey, nKeyKen ) ) ||
						(sSearchOption.bLoHiCase && 0 ==	 auto_memcmp( &(pCompareData[nNextWordFrom2]) , pszKey, nKeyKen ) )
					){
						/* GrepʂAszWorkɊi[ */
						SetGrepResult(
							szWork, &nWorkLen,
							pszFullPath, pszCodeName,
							//	Jun. 25, 2002 genta
							//	ʒu1n܂Ȃ̂1𑫂Kv
							nLine, nNextWordFrom2 + 1, pCompareData, nLineLen, nEolCodeLen,
							&(pCompareData[nNextWordFrom2]), nKeyKen,
							bGrepOutputLine, nGrepOutputStyle
						);
						if( 2 == nGrepOutputStyle ){
						/* WZ */
							if( !bOutFileName ){
								cmemMessage.AppendString( szWork0 );
								bOutFileName = TRUE;
							}
						}

						cmemMessage.AppendString( szWork, nWorkLen );
						++nHitCount;
						++(*pnHitCount);
						//	May 22, 2000 genta
						// if( 0 == ( (*pnHitCount) % 16 ) ){
							::SetDlgItemInt( hwndCancel, IDC_STATIC_HITCOUNT, *pnHitCount, FALSE );
						// }
					}
				}
				/* ݈ʒu̍E̒P̐擪ʒu𒲂ׂ */
				if( !CWordParse::SearchNextWordPosition( pCompareData, CLogicInt(nLineLen), nNextWordFrom, &nNextWordFrom, FALSE ) ){
					break;	//	̒PꂪB
				}
			}
		}
		else {
			/* 񌟍 */
			int nColmPrev = 0;
			//	Jun. 21, 2003 genta [v
			//	}b`ӏ1s畡oP[XWɁC
			//	}b`ӏ1s1oꍇOP[XƂƂ炦C
			//	[vpEł؂(bGrepOutputLine)tɂD
			while(1){
				pszRes = CSearchAgent::SearchString(
					pCompareData,
					nLineLen,
					0,
					pszKey,
					nKeyKen,
					pnKey_CharCharsArr,
					sSearchOption.bLoHiCase
				);
				if(!pszRes)break;

				nColm = pszRes - pCompareData + 1;

				/* GrepʂAszWorkɊi[ */
				SetGrepResult(
					szWork, &nWorkLen,
					pszFullPath, pszCodeName,
					nLine, nColm + nColmPrev, pCompareData, nLineLen, nEolCodeLen,
					pszRes, nKeyKen,
					bGrepOutputLine, nGrepOutputStyle
				);
				if( 2 == nGrepOutputStyle ){
				/* WZ */
					if( !bOutFileName ){
						cmemMessage.AppendString( szWork0 );
						bOutFileName = TRUE;
					}
				}

				cmemMessage.AppendString( szWork, nWorkLen );
				++nHitCount;
				++(*pnHitCount);
				//	May 22, 2000 genta
				if( 0 == ( (*pnHitCount) % 16 ) || *pnHitCount < 16 ){
					::SetDlgItemInt( hwndCancel, IDC_STATIC_HITCOUNT, *pnHitCount, FALSE );
				}
				
				//	Jun. 21, 2003 genta sPʂŏo͂ꍇ1Ώ\
				if ( bGrepOutputLine ) {
					break;
				}
				//	Tn߂ʒu␳
				//	2003.06.10 Moca }b`̌납玟̌Jn
				//	nClom : }b`ʒu
				//	matchlen : }b`̒
				int nPosDiff = nColm += nKeyKen - 1;
				pCompareData += nPosDiff;
				nLineLen -= nPosDiff;
				nColmPrev += nPosDiff;
			}
		}
	}

	// t@C𖾎Iɕ邪AŕȂƂ̓fXgN^ŕĂ
	cfl.FileClose();
	} // try
	catch( CError_FileOpen ){
		auto_sprintf( szWork, L"file open error [%ts]\r\n", pszFullPath );
		pcViewDst->GetCommander().Command_ADDTAIL( szWork, wcslen( szWork ) );
		return 0;
	}
	catch( CError_FileRead ){
		auto_sprintf( szWork, L"CEditView::DoGrepFile() t@C̓ǂݍݒɃG[܂B\r\n");
		pcViewDst->GetCommander().Command_ADDTAIL( szWork, wcslen( szWork ) );
	} // OI

	return nHitCount;
}


