#pragma once

#include "doc/CDocListener.h"
class CDlgCancel;
class CEditView;
class CGrepEnumKeys;

//	Jun. 26, 2001 genta	K\Cu̍ւ
//	Mar. 28, 2004 genta DoGrepFilesvȈ폜
class CGrepAgent : public CDocListenerEx{
public:
	CGrepAgent();

	// Cxg
	ECallbackResult OnBeforeClose();

	// Greps
	DWORD DoGrep(
		CEditView*				pcViewDst,
		const CNativeW*			pcmGrepKey,
		const CNativeT*			pcmGrepFile,
		const CNativeT*			pcmGrepFolder,
		BOOL					bGrepSubFolder,
		const SSearchOption&	sSearchOption,
		ECodeType				nGrepCharSet,	// 2002/09/21 Moca R[hZbgI
		BOOL					bGrepOutputLine,
		int						nGrepOutputStyle
	);

	// Greps
	int DoGrepTree(
		CEditView*				pcViewDst,
		CDlgCancel*				pcDlgCancel,		//!< [in] Cancel_CAOւ̃|C^
		HWND					hwndCancel,			//!< [in] Cancel_CAÕEBhEnh
		const wchar_t*			pszKey,				//!< [in] p^[
		int*					pnKey_CharCharsArr,	//!< [in] z(2byte/1byte)DP񌟍ŎgpD
		CGrepEnumKeys&			cGrepEnumKeys,		//!< [in] Ώۃt@Cp^[(!ŏOw)
		const TCHAR*			pszPath,			//!< [in] ΏۃpX
		BOOL					bGrepSubFolder,		//!< [in] TRUE: TutH_ċAIɒT / FALSE: Ȃ
		const SSearchOption&	sSearchOption,		//!< [in] IvV
		ECodeType				nGrepCharSet,		//!< [in] R[hZbg (0:F)`
		BOOL					bGrepOutputLine,	//!< [in] TRUE: qbgso / FALSE: qbgo
		int						nGrepOutputStyle,	//!< [in] o͌` 1: Normal, 2: WZ(t@CP)
		CBregexp*				pRegexp,			//!< [in] K\RpCf[^BɃRpCĂKv
		int						nNest,				//!< [in] lXgx
		int*					pnHitCount			//!< [i/o] qbg̍v
	);

	// Greps
	int DoGrepFile(
		CEditView*				pcViewDst,
		CDlgCancel*				pcDlgCancel,
		HWND					hwndCancel,
		const wchar_t*			pszKey,
		int*					pnKey_CharCharsArr,
		const TCHAR*			pszFile,
		const SSearchOption&	sSearchOption,
		ECodeType				nGrepCharSet,
		BOOL					bGrepOutputLine,
		int						nGrepOutputStyle,
		CBregexp*				pRegexp,		//	Jun. 27, 2001 genta	K\Cu̍ւ
		int*					pnHitCount,
		const TCHAR*			pszFullPath,
		CNativeW&				cmemMessage
	);

	// GrepʂpszWorkɊi[
	void SetGrepResult(
		// f[^i[
		wchar_t*		pWork,
		int*			pnWorkLen,
		// }b`t@C̏
		const TCHAR*	pszFullPath,	//	tpX
		const TCHAR*	pszCodeName,	//	R[h"[SJIS]"Ƃ
		// }b`s̏
		int				nLine,			//	}b`sԍ
		int				nColm,			//	}b`ԍ
		const wchar_t*	pCompareData,	//	s̕
		int				nLineLen,		//	s̒̕
		int				nEolCodeLen,	//	EOL̒
		// }b`̏
		const wchar_t*	pMatchData,		//	}b`
		int				nMatchLen,		//	}b`̒
		// IvV
		BOOL			bGrepOutputLine,
		int				nGrepOutputStyle
	);

public: //$$ 
	bool	m_bGrepMode;		//!< Grep[h
	bool	m_bGrepRunning;		//!< Grep
};
